2022-04-19 11:42:47

by Josh Poimboeuf

[permalink] [raw]
Subject: [PATCH v2 13/25] scripts: Create objdump-func helper script

Add a simple script which disassembles a single function from an object
file. Comes in handy for objtool warnings and kernel stack traces.

Originally-by: Peter Zijlstra <[email protected]>
Signed-off-by: Josh Poimboeuf <[email protected]>
---
scripts/objdump-func | 18 ++++++++++++++++++
1 file changed, 18 insertions(+)
create mode 100755 scripts/objdump-func

diff --git a/scripts/objdump-func b/scripts/objdump-func
new file mode 100755
index 000000000000..140646c456fc
--- /dev/null
+++ b/scripts/objdump-func
@@ -0,0 +1,18 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# Disassemble a single function.
+#
+# usage: objdump-func <file> <func>
+
+set -o errexit
+set -o nounset
+
+OBJDUMP="${CROSS_COMPILE:-}objdump"
+
+command -v awk >/dev/null 2>&1 || die "awk isn't installed"
+
+OBJ=$1; shift
+FUNC=$1; shift
+
+${OBJDUMP} -wdr $@ $OBJ | awk "/^\$/ { P=0; } /$FUNC[^>]*>:\$/ { P=1; O=strtonum(\"0x\" \$1); } { if (P) { o=strtonum(\"0x\" \$1); printf(\"%04x \", o-O); print \$0; } }"
--
2.34.1


2022-04-20 05:21:21

by Peter Zijlstra

[permalink] [raw]
Subject: Re: [PATCH v2 13/25] scripts: Create objdump-func helper script

On Mon, Apr 18, 2022 at 09:50:32AM -0700, Josh Poimboeuf wrote:
> Add a simple script which disassembles a single function from an object
> file. Comes in handy for objtool warnings and kernel stack traces.
>
> Originally-by: Peter Zijlstra <[email protected]>
> Signed-off-by: Josh Poimboeuf <[email protected]>
> ---
> scripts/objdump-func | 18 ++++++++++++++++++
> 1 file changed, 18 insertions(+)
> create mode 100755 scripts/objdump-func
>
> diff --git a/scripts/objdump-func b/scripts/objdump-func
> new file mode 100755
> index 000000000000..140646c456fc
> --- /dev/null
> +++ b/scripts/objdump-func
> @@ -0,0 +1,18 @@
> +#!/bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +#
> +# Disassemble a single function.
> +#
> +# usage: objdump-func <file> <func>
> +
> +set -o errexit
> +set -o nounset
> +
> +OBJDUMP="${CROSS_COMPILE:-}objdump"
> +
> +command -v awk >/dev/null 2>&1 || die "awk isn't installed"
> +
> +OBJ=$1; shift
> +FUNC=$1; shift
> +
> +${OBJDUMP} -wdr $@ $OBJ | awk "/^\$/ { P=0; } /$FUNC[^>]*>:\$/ { P=1; O=strtonum(\"0x\" \$1); } { if (P) { o=strtonum(\"0x\" \$1); printf(\"%04x \", o-O); print \$0; } }"
> --
> 2.34.1
>

This might rely on awk being gawk, I'm never very careful about those
things.

2022-04-22 17:56:29

by Josh Poimboeuf

[permalink] [raw]
Subject: Re: [PATCH v2 13/25] scripts: Create objdump-func helper script

On Tue, Apr 19, 2022 at 01:15:55PM +0200, Peter Zijlstra wrote:
> On Mon, Apr 18, 2022 at 09:50:32AM -0700, Josh Poimboeuf wrote:
> > Add a simple script which disassembles a single function from an object
> > file. Comes in handy for objtool warnings and kernel stack traces.
> >
> > Originally-by: Peter Zijlstra <[email protected]>
> > Signed-off-by: Josh Poimboeuf <[email protected]>
> > ---
> > scripts/objdump-func | 18 ++++++++++++++++++
> > 1 file changed, 18 insertions(+)
> > create mode 100755 scripts/objdump-func
> >
> > diff --git a/scripts/objdump-func b/scripts/objdump-func
> > new file mode 100755
> > index 000000000000..140646c456fc
> > --- /dev/null
> > +++ b/scripts/objdump-func
> > @@ -0,0 +1,18 @@
> > +#!/bin/bash
> > +# SPDX-License-Identifier: GPL-2.0
> > +#
> > +# Disassemble a single function.
> > +#
> > +# usage: objdump-func <file> <func>
> > +
> > +set -o errexit
> > +set -o nounset
> > +
> > +OBJDUMP="${CROSS_COMPILE:-}objdump"
> > +
> > +command -v awk >/dev/null 2>&1 || die "awk isn't installed"
> > +
> > +OBJ=$1; shift
> > +FUNC=$1; shift
> > +
> > +${OBJDUMP} -wdr $@ $OBJ | awk "/^\$/ { P=0; } /$FUNC[^>]*>:\$/ { P=1; O=strtonum(\"0x\" \$1); } { if (P) { o=strtonum(\"0x\" \$1); printf(\"%04x \", o-O); print \$0; } }"
> > --
> > 2.34.1
> >
>
> This might rely on awk being gawk, I'm never very careful about those
> things.

True, running with --posix I get

awk: cmd. line:1: (FILENAME=- FNR=17142) fatal: function `strtonum' not defined

The non-gawk users always ruin the party.

--
Josh